// SettingsDialogApparence.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "resource.h"   	// main symbols
#include "SysTrayPlay.h"
#include "SettingsDialog.h"
#include "SettingsDialogApparence.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "SeekDialog.h"
#include "EqualizerDlg.h"
#include "PlaylistDlg.h"
#include "AboutDlg.h"
#include "AutDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Bote de dialogue CSettingsDialogApparence

IMPLEMENT_MENUXP(CSettingsDialogApparence, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogApparence, CPropertyPage)

CSettingsDialogApparence::CSettingsDialogApparence() : CPropertyPage(CSettingsDialogApparence::IDD)
{
	startColor.SetColour(pMainFrame->mySkin.startColor);
	endColor.SetColour(pMainFrame->mySkin.endColor);
	showGradient = pMainFrame->showGradient ? TRUE : FALSE;
	showGradientSel = pMainFrame->showGradientSel ? TRUE : FALSE;
	showToolTip = pMainFrame->showToolTip ? TRUE : FALSE;
}

CSettingsDialogApparence::~CSettingsDialogApparence()
{
}

void CSettingsDialogApparence::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	DDX_Control(pDX, IDC_GRADIENTSTART, startColor);
	DDX_Control(pDX, IDC_GRADIENTEND, endColor);
	DDX_Check(pDX, IDC_SHOWGRADIENT, showGradient);
	DDX_Check(pDX, IDC_SHOWGRADIENTSEL, showGradientSel);
	DDX_Check(pDX, IDC_SHOWTOOLTIP, showToolTip);
	DDX_Text(pDX, IDC_EDIT1, SettingsDialog->toolTipText);
	DDX_Control(pDX, IDC_LOOK_TOOLTIP, m_btnLook);
}

BOOL CSettingsDialogApparence::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	m_Helper.translateWindowText(this, IDD_SETTINGS_APPARENCE);
	m_Helper.translateDlgItemText(this, IDC_LGRADIENTSTART);
	m_Helper.translateDlgItemText(this, IDC_LGRADIENTEND);
	m_Helper.translateDlgItemText(this, IDC_SHOWGRADIENT);
	m_Helper.translateDlgItemText(this, IDC_SHOWGRADIENTSEL);
	m_Helper.translateDlgItemText(this, IDC_SHOWTOOLTIP);
	m_Helper.translateDlgItemText(this, IDC_LCONTENTTOOLTIP);
	m_Helper.translateDlgItemText(this, IDC_LSECONDS);
	m_Helper.translateDlgItemText(this, IDC_LOOK_TOOLTIP);

	SettingsDialog->m_tooltip->AddTool(GetDlgItem(IDC_LOOK_TOOLTIP), SettingsDialog->toolTipText);
	SettingsDialog->m_tooltip->SetNotify();

	CWnd* pWnd = GetDlgItem(IDC_EDIT1);
	pWnd->SendMessage(WM_SETTEXT, 0, (LPARAM)SettingsDialog->toolTipText.GetString());

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
void CSettingsDialogApparence::OnPaint()
{
	CPropertyPage::OnPaint();
	CPaintDC dc(this);
	CWnd* pWnd = GetDlgItem(IDC_GRADIENTSAMPLE);
	DrawGradientSample(pWnd);
}

void CSettingsDialogApparence::OnOK()
{
	UpdateData(TRUE);

	pMainFrame->showGradient = (showGradient == TRUE);
	pMainFrame->showGradientSel = (showGradientSel == TRUE);
	
	AfxGetApp()->WriteProfileInt(_T("MenuXP"), _T("ShowGradient"), showGradient ? 1 : 0);
	AfxGetApp()->WriteProfileInt(_T("MenuXP"), _T("ShowGradientSel"), showGradientSel ? 1 : 0);

	pMainFrame->showToolTip = (showToolTip == TRUE);
	pMainFrame->mySkin.startColor = startColor.GetColour();
	pMainFrame->mySkin.endColor = endColor.GetColour();
	pMainFrame->mySkin.toolTipText = SettingsDialog->toolTipText;
	pMainFrame->mySkin.toolTipText.Replace(_T("\r\n"), _T("\\r\\n"));
	pMainFrame->mySkin.toolTipText.Replace(_T("\n"), _T("\\n"));
	pMainFrame->mySkin.toolTipText.Replace(_T("\t"), _T("\\t"));

	//Invalidation de toutes les boites de dialogues
	if (AboutDialog != NULL && AboutDialog->m_hWnd != NULL)
	{
		AboutDialog->CloseWindow();
	}
	if (AutDlg != NULL && AutDlg->m_hWnd != NULL)
	{
		AutDlg->CloseWindow();
	}
	if (EqualizerDlg != NULL && EqualizerDlg->m_hWnd != NULL)
	{
		EqualizerDlg->SaveWindowPosAndDestroy();
	}
	if (PlaylistDlg != NULL && PlaylistDlg->m_hWnd != NULL)
	{
		PlaylistDlg->SaveWindowPosAndDestroy();
	}
	if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
	{
		SeekDialog->SaveWindowPosAndDestroy();
	}

	AfxGetApp()->WriteProfileString(_T("MenuXP"), _T("GradientStart"), m_Helper.ConvertColorHexa(pMainFrame->mySkin.startColor));
	AfxGetApp()->WriteProfileString(_T("MenuXP"), _T("GradientEnd"), m_Helper.ConvertColorHexa(pMainFrame->mySkin.endColor));

	CPropertyPage::OnOK();
}

void CSettingsDialogApparence::DrawGradientSample(CWnd* pGradientSampleWnd)
{
	if (pGradientSampleWnd)
	{
		CDC* pDC = pGradientSampleWnd->GetDC();
		HDC hDC = ::GetWindowDC(pGradientSampleWnd->m_hWnd);
		CRect rect;
		pGradientSampleWnd->GetClientRect(&rect);

		HBITMAP bm = CreateCompatibleBitmap(hDC, rect.Width(), rect.Height());
		rect.bottom--;
		rect.right--;
		SelectObject(hDC, bm);

		SeekDialog->DrawGradient(CDC::FromHandle(hDC), startColor.GetColour(), endColor.GetColour(), &rect);
		pDC->StretchBlt(0, 0, rect.Width(), rect.Height(), CDC::FromHandle(hDC), 0, 0, rect.Width(), rect.Height(), SRCPAINT);
		CPen pen(PS_SOLID, 1, RGB(0, 0, 0));
		pDC->SelectObject(pen);
		pDC->MoveTo(rect.TopLeft());
		pDC->LineTo(CPoint(rect.right, rect.top));
		pDC->LineTo(rect.BottomRight());
		pDC->LineTo(CPoint(rect.left, rect.bottom));
		pDC->LineTo(rect.TopLeft());
		::ReleaseDC(pGradientSampleWnd->m_hWnd, hDC);
		DeleteObject(hDC);
	}
}

void CSettingsDialogApparence::OnChangeTooltipText()
{
	UpdateData(TRUE);
	SettingsDialog->m_tooltip->RemoveAllTools();
	SettingsDialog->m_tooltip->AddTool(SettingsDialog->m_SettingsDialogApparence.GetDlgItem(IDC_LOOK_TOOLTIP), SettingsDialog->toolTipText);
	SettingsDialog->m_tooltip->AddTool(SettingsDialog->m_SettingsDialogApparenceTooltip.GetDlgItem(IDC_LOOK_TOOLTIP), SettingsDialog->toolTipText);
	SettingsDialog->m_tooltip->AddTool(SettingsDialog->m_SettingsDialogApparenceSkins.GetDlgItem(IDC_LOOK_TOOLTIP), SettingsDialog->toolTipText);
}

BOOL CSettingsDialogApparence::PreTranslateMessage(MSG* pMsg)
{
	SettingsDialog->m_tooltip->RelayEvent(pMsg);

	return CPropertyPage::PreTranslateMessage(pMsg);
}

BEGIN_MESSAGE_MAP(CSettingsDialogApparence, CPropertyPage)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeTooltipText)
	ON_WM_PAINT()
END_MESSAGE_MAP()
