// TagEditor.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"   	// main symbols
#include "systrayplay.h"
#include "TagEditor.h"
#include "MainWnd.h"
#include "MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CStringArray genres;

/////////////////////////////////////////////////////////////////////////////
// CTagEditor dialog


CTagEditor::CTagEditor() : CDialog(CTagEditor::IDD)
{
	m_genre = -1;
	m_album = _T("");
	m_artist = _T("");
	m_comment = _T("");
	m_composer = _T("");
	m_filename = _T("");
	m_title = _T("");
	m_year = _T("");
	m_keep1 = FALSE;
	m_keep2 = FALSE;
	m_keep3 = FALSE;
	m_keep4 = FALSE;
	m_keep5 = FALSE;
	m_keep6 = FALSE;
}


BEGIN_MESSAGE_MAP(CTagEditor, CDialog)
	ON_BN_CLICKED(IDC_REMOVE_TAG, OnRemoveTag)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTagEditor message handlers

void CTagEditor::DoDataExchange(CDataExchange* pDX)
{
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_GENRE, m_c_genre);
	DDX_Control(pDX, IDC_EDIT_TITLE, m_c_title);
	DDX_Control(pDX, IDC_EDIT_COMMENT, m_c_comment);
	DDX_Control(pDX, IDC_EDIT_COMPOSER, m_c_composer);
	DDX_Control(pDX, IDC_EDIT_ARTIST, m_c_artist);
	DDX_Control(pDX, IDC_EDIT_ALBUM, m_c_album);
	DDX_Control(pDX, IDC_EDIT_YEAR, m_c_year);
	DDX_CBIndex(pDX, IDC_COMBO_GENRE, m_genre);
	DDX_Text(pDX, IDC_EDIT_ALBUM, m_album);
	DDX_Text(pDX, IDC_EDIT_ARTIST, m_artist);
	DDX_Text(pDX, IDC_EDIT_COMMENT, m_comment);
	DDX_Text(pDX, IDC_EDIT_FILENAME, m_filename);
	DDX_Text(pDX, IDC_EDIT_TITLE, m_title);
	DDX_Text(pDX, IDC_EDIT_YEAR, m_year);
	DDX_Check(pDX, IDC_KEEP1, m_keep1);
	DDX_Check(pDX, IDC_KEEP2, m_keep2);
	DDX_Check(pDX, IDC_KEEP3, m_keep3);
	DDX_Check(pDX, IDC_KEEP4, m_keep4);
	DDX_Check(pDX, IDC_KEEP5, m_keep5);
	DDX_Check(pDX, IDC_KEEP6, m_keep6);
	DDX_Control(pDX, IDC_REMOVE_TAG, m_btn_RemoveTag);
	DDX_Control(pDX, IDC_KEEP1, m_btn_Keep1);
	DDX_Control(pDX, IDC_KEEP2, m_btn_Keep2);
	DDX_Control(pDX, IDC_KEEP3, m_btn_Keep3);
	DDX_Control(pDX, IDC_KEEP4, m_btn_Keep4);
	DDX_Control(pDX, IDC_KEEP5, m_btn_Keep5);
	DDX_Control(pDX, IDC_KEEP6, m_btn_Keep6);
	DDX_Control(pDX, IDOK, m_btn_Ok);
	DDX_Control(pDX, IDCANCEL, m_btn_Cancel);
}


BOOL CTagEditor::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_Helper.translateWindowText(this, IDD_TAGEDIT);
	m_Helper.translateDlgItemText(this, IDC_LFILENAME);
	m_Helper.translateDlgItemText(this, IDC_LTITLE);
	m_Helper.translateDlgItemText(this, IDC_LARTIST);
	m_Helper.translateDlgItemText(this, IDC_LALBUM);
	m_Helper.translateDlgItemText(this, IDC_LYEAR);
	m_Helper.translateDlgItemText(this, IDC_LCOMMENT);
	m_Helper.translateDlgItemText(this, IDC_LCOMPOSER);
	m_Helper.translateDlgItemText(this, IDC_LGENRE);
	m_Helper.translateDlgItemText(this, IDC_REMOVE_TAG);
	m_Helper.translateDlgItemText(this, IDC_KEEP1);
	m_Helper.translateDlgItemText(this, IDC_KEEP2);
	m_Helper.translateDlgItemText(this, IDC_KEEP3);
	m_Helper.translateDlgItemText(this, IDC_KEEP4);
	m_Helper.translateDlgItemText(this, IDC_KEEP5);
	m_Helper.translateDlgItemText(this, IDC_KEEP6);
	m_Helper.translateDlgItemText(this, IDOK);
	m_Helper.translateDlgItemText(this, IDCANCEL);

	m_c_genre.AddString(_T(""));
	for (int i = 0; i < genres.GetSize(); i++)
		m_c_genre.AddString(genres[i]);
	if (m_genre != -1)
		m_c_genre.SetCurSel(m_c_genre.FindString(0, genres[m_genre]));
	m_c_title.LimitText(30);
	m_c_artist.LimitText(30);
	m_c_album.LimitText(30);
	m_c_year.LimitText(4);
	m_c_comment.LimitText(30);
	m_c_composer.LimitText(30);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CTagEditor::OnRemoveTag()
{
	CFile mpfile;

	DWORD attrs = ::GetFileAttributes(m_filename);
	::SetFileAttributes(m_filename, attrs & !FILE_ATTRIBUTE_READONLY);
	if (mpfile.Open(m_filename, CFile::modeReadWrite | CFile::shareDenyNone))
	{
		UpdateData(true);

		ULONGLONG taille = mpfile.GetLength();
		if (taille < 129)
		{
			mpfile.Close();
			return;
		}
		mpfile.Seek(-128, CFile::end);

		char buf[31];
		buf[30] = '\0';
		mpfile.Read(buf, 3);buf[3] = '\0';
		if (strcmp(buf, "TAG") == 0)
			mpfile.SetLength(taille - 128);
		mpfile.Close();
	}
	::SetFileAttributes(m_filename, attrs);

	if (!m_keep1)
		m_c_title.SetWindowText(_T(""));
	if (!m_keep2)
		m_c_artist.SetWindowText(_T(""));
	if (!m_keep3)
		m_c_album.SetWindowText(_T(""));
	if (!m_keep4)
		m_c_year.SetWindowText(_T(""));
	if (!m_keep5)
		m_c_comment.SetWindowText(_T(""));
	if (!m_keep6)
		m_c_genre.SetCurSel(0);
	UpdateData(true);
	CDialog::OnOK();
}

void CTagEditor::OnOK()
{
	UpdateData(true);
	DWORD attrs = ::GetFileAttributes(m_filename);
	::SetFileAttributes(m_filename, attrs & !FILE_ATTRIBUTE_READONLY);
	CFile mpfile;
	if (mpfile.Open(m_filename, CFile::modeReadWrite | CFile::shareDenyNone))
	{
		TRY
		{
			TCHAR buf[31];
			if (mpfile.GetLength() > 128)
			{
				mpfile.Seek(-128, CFile::end);

				buf[30] = '\0';
				mpfile.Read(buf, 3);buf[3] = '\0';
				if (_tcscmp(buf, _T("TAG")) != 0)
				{
					mpfile.SeekToEnd();
					_tcscpy(buf, _T("TAG"));
					mpfile.Write(buf, 3);
				}
			}
			else
			{
				mpfile.SeekToEnd();
				_tcscpy(buf, _T("TAG"));
				mpfile.Write(buf, 3);
			}

			m_title += "                                ";
			mpfile.Write(LPCTSTR(m_title), 30);

			m_artist += "                                ";
			mpfile.Write(LPCTSTR(m_artist), 30);

			m_album += "                                ";
			mpfile.Write(LPCTSTR(m_album), 30);

			m_year += "     ";
			mpfile.Write(LPCTSTR(m_year), 4);

			m_comment += "                                ";
			mpfile.Write(LPCTSTR(m_comment), 30);
			/*
																				m_composer += "                                ";
																				mpfile.Write(LPCTSTR(m_composer), 30);
																	*/

			if (m_genre > 0)
			{
				m_c_genre.GetLBText(m_genre, buf);
				CString buf2;
				buf2 = buf;
				for (int i = 0; i < genres.GetSize(); i++)
					if (genres[i] == buf2)
					{
						buf[0] = (char)i;
						break;
					}
			}
			else
				buf[0] = -1;
			mpfile.Write(buf, 1);
		} CATCH(CFileException, e)
		{
		};
		END_CATCH
		mpfile. Close();
	}
	::SetFileAttributes(m_filename, attrs);

	CDialog::OnOK();
}

