#ifndef _WA_GEN_H_
#define _WA_GEN_H_

typedef struct
{
	int version;
	TCHAR* description;
	int (*init)();
	void (*config)();
	void (*quit)();
	HWND hwndParent;
	HINSTANCE hDllInstance;
} winampGeneralPurposePlugin;

class GenInterface
{
private:
	CString filePath;
public:
	GenInterface(CString dllPath)
	{
		filePath = dllPath;
	};
	~GenInterface()
	{
	};

	int GetVersion()
	{
		return 0;
	};  			// module type (IN_VER)
	TCHAR* GetDescription()
	{
		return _T("");
	};  		// description of module, with version string

public:

	void SethwndParent(HWND hWnd);   // winamp's main window (filled gen by winamp)
	void SethDllInstance(HINSTANCE hDLL);   // DLL instance handle (Also filled gen by winamp)

	void Config()
	{
		// configuration dialog
	}

	int Init()
	{
		return 0;
	}

	void Quit()
	{
		// Quit
	}
	CString GetFilePath()
	{
		return filePath;
	}
	CString GetFileName()
	{
		CString tmp = filePath;
		TCHAR path[MAX_PATH];
		TCHAR fname[MAX_PATH];
		TCHAR ext[MAX_PATH];
		strcpy(path, (TCHAR *)(LPCTSTR)filePath);
		_splitpath(path, NULL, NULL, fname, ext);
		tmp.Format(_T("%s%s"), fname, ext);
		return tmp;
	}
	void SetFilePath(CString nFilePath)
	{
		filePath = nFilePath;
	}

	winampGeneralPurposePlugin* GetWinampGeneralPurposePlugin();
};

#endif